/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using Org.OpenAPITools.Client;
using Org.OpenAPITools.Model;

namespace Org.OpenAPITools.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IClass6BanApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Test ban settings
        /// </summary>
        /// <remarks>
        /// Send the phone number to find out if the instance is banning it
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>BanTestStatus</returns>
        BanTestStatus BanTest (BanTestAction banTestAction);

        /// <summary>
        /// Test ban settings
        /// </summary>
        /// <remarks>
        /// Send the phone number to find out if the instance is banning it
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>ApiResponse of BanTestStatus</returns>
        ApiResponse<BanTestStatus> BanTestWithHttpInfo (BanTestAction banTestAction);
        /// <summary>
        /// Get settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>BanSettings</returns>
        BanSettings GetBanSettings ();

        /// <summary>
        /// Get settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of BanSettings</returns>
        ApiResponse<BanSettings> GetBanSettingsWithHttpInfo ();
        /// <summary>
        /// Set settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>BanSettings</returns>
        BanSettings SetBanSettings (BanSettings banSettings);

        /// <summary>
        /// Set settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>ApiResponse of BanSettings</returns>
        ApiResponse<BanSettings> SetBanSettingsWithHttpInfo (BanSettings banSettings);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Test ban settings
        /// </summary>
        /// <remarks>
        /// Send the phone number to find out if the instance is banning it
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>Task of BanTestStatus</returns>
        System.Threading.Tasks.Task<BanTestStatus> BanTestAsync (BanTestAction banTestAction);

        /// <summary>
        /// Test ban settings
        /// </summary>
        /// <remarks>
        /// Send the phone number to find out if the instance is banning it
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>Task of ApiResponse (BanTestStatus)</returns>
        System.Threading.Tasks.Task<ApiResponse<BanTestStatus>> BanTestAsyncWithHttpInfo (BanTestAction banTestAction);
        /// <summary>
        /// Get settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of BanSettings</returns>
        System.Threading.Tasks.Task<BanSettings> GetBanSettingsAsync ();

        /// <summary>
        /// Get settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (BanSettings)</returns>
        System.Threading.Tasks.Task<ApiResponse<BanSettings>> GetBanSettingsAsyncWithHttpInfo ();
        /// <summary>
        /// Set settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>Task of BanSettings</returns>
        System.Threading.Tasks.Task<BanSettings> SetBanSettingsAsync (BanSettings banSettings);

        /// <summary>
        /// Set settings
        /// </summary>
        /// <remarks>
        /// **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </remarks>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>Task of ApiResponse (BanSettings)</returns>
        System.Threading.Tasks.Task<ApiResponse<BanSettings>> SetBanSettingsAsyncWithHttpInfo (BanSettings banSettings);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class Class6BanApi : IClass6BanApi
    {
        private Org.OpenAPITools.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="Class6BanApi"/> class.
        /// </summary>
        /// <returns></returns>
        public Class6BanApi(String basePath)
        {
            this.Configuration = new Org.OpenAPITools.Client.Configuration { BasePath = basePath };

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class6BanApi"/> class
        /// </summary>
        /// <returns></returns>
        public Class6BanApi()
        {
            this.Configuration = Org.OpenAPITools.Client.Configuration.Default;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Class6BanApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public Class6BanApi(Org.OpenAPITools.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Org.OpenAPITools.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = Org.OpenAPITools.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Org.OpenAPITools.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Org.OpenAPITools.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Test ban settings Send the phone number to find out if the instance is banning it
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>BanTestStatus</returns>
        public BanTestStatus BanTest (BanTestAction banTestAction)
        {
             ApiResponse<BanTestStatus> localVarResponse = BanTestWithHttpInfo(banTestAction);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Test ban settings Send the phone number to find out if the instance is banning it
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>ApiResponse of BanTestStatus</returns>
        public ApiResponse<BanTestStatus> BanTestWithHttpInfo (BanTestAction banTestAction)
        {
            // verify the required parameter 'banTestAction' is set
            if (banTestAction == null)
                throw new ApiException(400, "Missing required parameter 'banTestAction' when calling Class6BanApi->BanTest");

            var localVarPath = "/banTest";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (banTestAction != null && banTestAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(banTestAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = banTestAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BanTest", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanTestStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanTestStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanTestStatus)));
        }

        /// <summary>
        /// Test ban settings Send the phone number to find out if the instance is banning it
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>Task of BanTestStatus</returns>
        public async System.Threading.Tasks.Task<BanTestStatus> BanTestAsync (BanTestAction banTestAction)
        {
             ApiResponse<BanTestStatus> localVarResponse = await BanTestAsyncWithHttpInfo(banTestAction);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Test ban settings Send the phone number to find out if the instance is banning it
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banTestAction"></param>
        /// <returns>Task of ApiResponse (BanTestStatus)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BanTestStatus>> BanTestAsyncWithHttpInfo (BanTestAction banTestAction)
        {
            // verify the required parameter 'banTestAction' is set
            if (banTestAction == null)
                throw new ApiException(400, "Missing required parameter 'banTestAction' when calling Class6BanApi->BanTest");

            var localVarPath = "/banTest";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (banTestAction != null && banTestAction.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(banTestAction); // http body (model) parameter
            }
            else
            {
                localVarPostBody = banTestAction; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("BanTest", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanTestStatus>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanTestStatus) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanTestStatus)));
        }

        /// <summary>
        /// Get settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>BanSettings</returns>
        public BanSettings GetBanSettings ()
        {
             ApiResponse<BanSettings> localVarResponse = GetBanSettingsWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of BanSettings</returns>
        public ApiResponse<BanSettings> GetBanSettingsWithHttpInfo ()
        {

            var localVarPath = "/banSettings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBanSettings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanSettings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanSettings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanSettings)));
        }

        /// <summary>
        /// Get settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of BanSettings</returns>
        public async System.Threading.Tasks.Task<BanSettings> GetBanSettingsAsync ()
        {
             ApiResponse<BanSettings> localVarResponse = await GetBanSettingsAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (BanSettings)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BanSettings>> GetBanSettingsAsyncWithHttpInfo ()
        {

            var localVarPath = "/banSettings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetBanSettings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanSettings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanSettings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanSettings)));
        }

        /// <summary>
        /// Set settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>BanSettings</returns>
        public BanSettings SetBanSettings (BanSettings banSettings)
        {
             ApiResponse<BanSettings> localVarResponse = SetBanSettingsWithHttpInfo(banSettings);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Set settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>ApiResponse of BanSettings</returns>
        public ApiResponse<BanSettings> SetBanSettingsWithHttpInfo (BanSettings banSettings)
        {
            // verify the required parameter 'banSettings' is set
            if (banSettings == null)
                throw new ApiException(400, "Missing required parameter 'banSettings' when calling Class6BanApi->SetBanSettings");

            var localVarPath = "/banSettings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (banSettings != null && banSettings.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(banSettings); // http body (model) parameter
            }
            else
            {
                localVarPostBody = banSettings; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SetBanSettings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanSettings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanSettings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanSettings)));
        }

        /// <summary>
        /// Set settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>Task of BanSettings</returns>
        public async System.Threading.Tasks.Task<BanSettings> SetBanSettingsAsync (BanSettings banSettings)
        {
             ApiResponse<BanSettings> localVarResponse = await SetBanSettingsAsyncWithHttpInfo(banSettings);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Set settings **banPhoneMask** - Regular expression on which bans on numbers will be sent  **preBanMessage** - Warning message If it is set, a message will be sent before sending the ban.
        /// </summary>
        /// <exception cref="Org.OpenAPITools.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="banSettings"></param>
        /// <returns>Task of ApiResponse (BanSettings)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<BanSettings>> SetBanSettingsAsyncWithHttpInfo (BanSettings banSettings)
        {
            // verify the required parameter 'banSettings' is set
            if (banSettings == null)
                throw new ApiException(400, "Missing required parameter 'banSettings' when calling Class6BanApi->SetBanSettings");

            var localVarPath = "/banSettings";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (banSettings != null && banSettings.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(banSettings); // http body (model) parameter
            }
            else
            {
                localVarPostBody = banSettings; // byte array
            }

            // authentication (instanceId) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("instanceId")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "instanceId", this.Configuration.GetApiKeyWithPrefix("instanceId")));
            }
            // authentication (token) required
            if (!String.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("token")))
            {
                localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "token", this.Configuration.GetApiKeyWithPrefix("token")));
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("SetBanSettings", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<BanSettings>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (BanSettings) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(BanSettings)));
        }

    }
}
