/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// BanSettings
    /// </summary>
    [DataContract]
    public partial class BanSettings :  IEquatable<BanSettings>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BanSettings" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected BanSettings() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="BanSettings" /> class.
        /// </summary>
        /// <param name="banPhoneMask">banPhoneMask (required).</param>
        /// <param name="preBanMessage">preBanMessage (required).</param>
        /// <param name="set">Flag indicating that the current request has changed ban settings (required).</param>
        public BanSettings(string banPhoneMask = default(string), string preBanMessage = default(string), bool set = default(bool))
        {
            // to ensure "banPhoneMask" is required (not null)
            if (banPhoneMask == null)
            {
                throw new InvalidDataException("banPhoneMask is a required property for BanSettings and cannot be null");
            }
            else
            {
                this.BanPhoneMask = banPhoneMask;
            }
            
            this.BanPhoneMask = banPhoneMask;
            // to ensure "preBanMessage" is required (not null)
            if (preBanMessage == null)
            {
                throw new InvalidDataException("preBanMessage is a required property for BanSettings and cannot be null");
            }
            else
            {
                this.PreBanMessage = preBanMessage;
            }
            
            this.PreBanMessage = preBanMessage;
            // to ensure "set" is required (not null)
            if (set == null)
            {
                throw new InvalidDataException("set is a required property for BanSettings and cannot be null");
            }
            else
            {
                this.Set = set;
            }
            
        }
        
        /// <summary>
        /// Gets or Sets BanPhoneMask
        /// </summary>
        [DataMember(Name="banPhoneMask", EmitDefaultValue=true)]
        public string BanPhoneMask { get; set; }

        /// <summary>
        /// Gets or Sets PreBanMessage
        /// </summary>
        [DataMember(Name="preBanMessage", EmitDefaultValue=true)]
        public string PreBanMessage { get; set; }

        /// <summary>
        /// Flag indicating that the current request has changed ban settings
        /// </summary>
        /// <value>Flag indicating that the current request has changed ban settings</value>
        [DataMember(Name="set", EmitDefaultValue=false)]
        public bool Set { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BanSettings {\n");
            sb.Append("  BanPhoneMask: ").Append(BanPhoneMask).Append("\n");
            sb.Append("  PreBanMessage: ").Append(PreBanMessage).Append("\n");
            sb.Append("  Set: ").Append(Set).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BanSettings);
        }

        /// <summary>
        /// Returns true if BanSettings instances are equal
        /// </summary>
        /// <param name="input">Instance of BanSettings to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BanSettings input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BanPhoneMask == input.BanPhoneMask ||
                    (this.BanPhoneMask != null &&
                    this.BanPhoneMask.Equals(input.BanPhoneMask))
                ) && 
                (
                    this.PreBanMessage == input.PreBanMessage ||
                    (this.PreBanMessage != null &&
                    this.PreBanMessage.Equals(input.PreBanMessage))
                ) && 
                (
                    this.Set == input.Set ||
                    (this.Set != null &&
                    this.Set.Equals(input.Set))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BanPhoneMask != null)
                    hashCode = hashCode * 59 + this.BanPhoneMask.GetHashCode();
                if (this.PreBanMessage != null)
                    hashCode = hashCode * 59 + this.PreBanMessage.GetHashCode();
                if (this.Set != null)
                    hashCode = hashCode * 59 + this.Set.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
