/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// ForwardMessageRequest
    /// </summary>
    [DataContract]
    public partial class ForwardMessageRequest :  IEquatable<ForwardMessageRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ForwardMessageRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ForwardMessageRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ForwardMessageRequest" /> class.
        /// </summary>
        /// <param name="chatId">**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter..</param>
        /// <param name="phone">**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486..</param>
        /// <param name="messageId">Message ID | Message IDs array. Example: \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot; or [\&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot;, \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82G\&quot;] (required).</param>
        public ForwardMessageRequest(string chatId = default(string), int phone = default(int), string messageId = default(string))
        {
            // to ensure "messageId" is required (not null)
            if (messageId == null)
            {
                throw new InvalidDataException("messageId is a required property for ForwardMessageRequest and cannot be null");
            }
            else
            {
                this.MessageId = messageId;
            }
            
            this.ChatId = chatId;
            this.Phone = phone;
        }
        
        /// <summary>
        /// **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
        /// </summary>
        /// <value>**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.</value>
        [DataMember(Name="chatId", EmitDefaultValue=false)]
        public string ChatId { get; set; }

        /// <summary>
        /// **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
        /// </summary>
        /// <value>**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.</value>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public int Phone { get; set; }

        /// <summary>
        /// Message ID | Message IDs array. Example: \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot; or [\&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot;, \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82G\&quot;]
        /// </summary>
        /// <value>Message ID | Message IDs array. Example: \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot; or [\&quot;false_6590996758@c.us_3EB03104D2B84CEAD82F\&quot;, \&quot;false_6590996758@c.us_3EB03104D2B84CEAD82G\&quot;]</value>
        [DataMember(Name="messageId", EmitDefaultValue=false)]
        public string MessageId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ForwardMessageRequest {\n");
            sb.Append("  ChatId: ").Append(ChatId).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("  MessageId: ").Append(MessageId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ForwardMessageRequest);
        }

        /// <summary>
        /// Returns true if ForwardMessageRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ForwardMessageRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ForwardMessageRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ChatId == input.ChatId ||
                    (this.ChatId != null &&
                    this.ChatId.Equals(input.ChatId))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                ) && 
                (
                    this.MessageId == input.MessageId ||
                    (this.MessageId != null &&
                    this.MessageId.Equals(input.MessageId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ChatId != null)
                    hashCode = hashCode * 59 + this.ChatId.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                if (this.MessageId != null)
                    hashCode = hashCode * 59 + this.MessageId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
