/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// GroupParticipantAction
    /// </summary>
    [DataContract]
    public partial class GroupParticipantAction :  IEquatable<GroupParticipantAction>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupParticipantAction" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GroupParticipantAction() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupParticipantAction" /> class.
        /// </summary>
        /// <param name="groupId">Chat ID from the chat list. Examples: 19680561234-1479621234@g.us for the group. (required).</param>
        /// <param name="participantChatId">**Required if participantPhone is not set**  Chat ID from the message list. Examples: 17633123456@c.us. Used instead of the participantPhone parameter. (required).</param>
        /// <param name="participantPhone">**Required if participantChatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486..</param>
        public GroupParticipantAction(string groupId = default(string), string participantChatId = default(string), int participantPhone = default(int))
        {
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for GroupParticipantAction and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            
            // to ensure "participantChatId" is required (not null)
            if (participantChatId == null)
            {
                throw new InvalidDataException("participantChatId is a required property for GroupParticipantAction and cannot be null");
            }
            else
            {
                this.ParticipantChatId = participantChatId;
            }
            
            this.ParticipantPhone = participantPhone;
        }
        
        /// <summary>
        /// Chat ID from the chat list. Examples: 19680561234-1479621234@g.us for the group.
        /// </summary>
        /// <value>Chat ID from the chat list. Examples: 19680561234-1479621234@g.us for the group.</value>
        [DataMember(Name="groupId", EmitDefaultValue=false)]
        public string GroupId { get; set; }

        /// <summary>
        /// **Required if participantPhone is not set**  Chat ID from the message list. Examples: 17633123456@c.us. Used instead of the participantPhone parameter.
        /// </summary>
        /// <value>**Required if participantPhone is not set**  Chat ID from the message list. Examples: 17633123456@c.us. Used instead of the participantPhone parameter.</value>
        [DataMember(Name="participantChatId", EmitDefaultValue=false)]
        public string ParticipantChatId { get; set; }

        /// <summary>
        /// **Required if participantChatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
        /// </summary>
        /// <value>**Required if participantChatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.</value>
        [DataMember(Name="participantPhone", EmitDefaultValue=false)]
        public int ParticipantPhone { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GroupParticipantAction {\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  ParticipantChatId: ").Append(ParticipantChatId).Append("\n");
            sb.Append("  ParticipantPhone: ").Append(ParticipantPhone).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GroupParticipantAction);
        }

        /// <summary>
        /// Returns true if GroupParticipantAction instances are equal
        /// </summary>
        /// <param name="input">Instance of GroupParticipantAction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GroupParticipantAction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && 
                (
                    this.ParticipantChatId == input.ParticipantChatId ||
                    (this.ParticipantChatId != null &&
                    this.ParticipantChatId.Equals(input.ParticipantChatId))
                ) && 
                (
                    this.ParticipantPhone == input.ParticipantPhone ||
                    (this.ParticipantPhone != null &&
                    this.ParticipantPhone.Equals(input.ParticipantPhone))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.ParticipantChatId != null)
                    hashCode = hashCode * 59 + this.ParticipantChatId.GetHashCode();
                if (this.ParticipantPhone != null)
                    hashCode = hashCode * 59 + this.ParticipantPhone.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
