/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// InlineResponse2005
    /// </summary>
    [DataContract]
    public partial class InlineResponse2005 :  IEquatable<InlineResponse2005>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2005" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected InlineResponse2005() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="InlineResponse2005" /> class.
        /// </summary>
        /// <param name="webhookUrl">webhookUrl.</param>
        /// <param name="ackNotificationsOn">ackNotificationsOn.</param>
        /// <param name="chatUpdateOn">chatUpdateOn.</param>
        /// <param name="videoUploadOn">videoUploadOn.</param>
        /// <param name="proxy">proxy.</param>
        /// <param name="guaranteedHooks">guaranteedHooks.</param>
        /// <param name="ignoreOldMessages">ignoreOldMessages.</param>
        /// <param name="processArchive">processArchive.</param>
        /// <param name="instanceStatuses">instanceStatuses.</param>
        /// <param name="webhookStatuses">webhookStatuses.</param>
        /// <param name="statusNotificationsOn">statusNotificationsOn.</param>
        /// <param name="update">update (required).</param>
        public InlineResponse2005(string webhookUrl = default(string), bool? ackNotificationsOn = default(bool?), bool? chatUpdateOn = default(bool?), bool? videoUploadOn = default(bool?), string proxy = default(string), bool? guaranteedHooks = default(bool?), bool? ignoreOldMessages = default(bool?), bool? processArchive = default(bool?), bool? instanceStatuses = default(bool?), bool? webhookStatuses = default(bool?), bool? statusNotificationsOn = default(bool?), InlineResponse2005Update update = default(InlineResponse2005Update))
        {
            this.WebhookUrl = webhookUrl;
            this.AckNotificationsOn = ackNotificationsOn;
            this.ChatUpdateOn = chatUpdateOn;
            this.VideoUploadOn = videoUploadOn;
            this.Proxy = proxy;
            this.GuaranteedHooks = guaranteedHooks;
            this.IgnoreOldMessages = ignoreOldMessages;
            this.ProcessArchive = processArchive;
            this.InstanceStatuses = instanceStatuses;
            this.WebhookStatuses = webhookStatuses;
            this.StatusNotificationsOn = statusNotificationsOn;
            // to ensure "update" is required (not null)
            if (update == null)
            {
                throw new InvalidDataException("update is a required property for InlineResponse2005 and cannot be null");
            }
            else
            {
                this.Update = update;
            }
            
            this.WebhookUrl = webhookUrl;
            this.AckNotificationsOn = ackNotificationsOn;
            this.ChatUpdateOn = chatUpdateOn;
            this.VideoUploadOn = videoUploadOn;
            this.Proxy = proxy;
            this.GuaranteedHooks = guaranteedHooks;
            this.IgnoreOldMessages = ignoreOldMessages;
            this.ProcessArchive = processArchive;
            this.InstanceStatuses = instanceStatuses;
            this.WebhookStatuses = webhookStatuses;
            this.StatusNotificationsOn = statusNotificationsOn;
        }
        
        /// <summary>
        /// Gets or Sets WebhookUrl
        /// </summary>
        [DataMember(Name="webhookUrl", EmitDefaultValue=true)]
        public string WebhookUrl { get; set; }

        /// <summary>
        /// Gets or Sets AckNotificationsOn
        /// </summary>
        [DataMember(Name="ackNotificationsOn", EmitDefaultValue=true)]
        public bool? AckNotificationsOn { get; set; }

        /// <summary>
        /// Gets or Sets ChatUpdateOn
        /// </summary>
        [DataMember(Name="chatUpdateOn", EmitDefaultValue=true)]
        public bool? ChatUpdateOn { get; set; }

        /// <summary>
        /// Gets or Sets VideoUploadOn
        /// </summary>
        [DataMember(Name="videoUploadOn", EmitDefaultValue=true)]
        public bool? VideoUploadOn { get; set; }

        /// <summary>
        /// Gets or Sets Proxy
        /// </summary>
        [DataMember(Name="proxy", EmitDefaultValue=true)]
        public string Proxy { get; set; }

        /// <summary>
        /// Gets or Sets GuaranteedHooks
        /// </summary>
        [DataMember(Name="guaranteedHooks", EmitDefaultValue=true)]
        public bool? GuaranteedHooks { get; set; }

        /// <summary>
        /// Gets or Sets IgnoreOldMessages
        /// </summary>
        [DataMember(Name="ignoreOldMessages", EmitDefaultValue=true)]
        public bool? IgnoreOldMessages { get; set; }

        /// <summary>
        /// Gets or Sets ProcessArchive
        /// </summary>
        [DataMember(Name="processArchive", EmitDefaultValue=true)]
        public bool? ProcessArchive { get; set; }

        /// <summary>
        /// Gets or Sets InstanceStatuses
        /// </summary>
        [DataMember(Name="instanceStatuses", EmitDefaultValue=true)]
        public bool? InstanceStatuses { get; set; }

        /// <summary>
        /// Gets or Sets WebhookStatuses
        /// </summary>
        [DataMember(Name="webhookStatuses", EmitDefaultValue=true)]
        public bool? WebhookStatuses { get; set; }

        /// <summary>
        /// Gets or Sets StatusNotificationsOn
        /// </summary>
        [DataMember(Name="statusNotificationsOn", EmitDefaultValue=true)]
        public bool? StatusNotificationsOn { get; set; }

        /// <summary>
        /// Gets or Sets Update
        /// </summary>
        [DataMember(Name="update", EmitDefaultValue=false)]
        public InlineResponse2005Update Update { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InlineResponse2005 {\n");
            sb.Append("  WebhookUrl: ").Append(WebhookUrl).Append("\n");
            sb.Append("  AckNotificationsOn: ").Append(AckNotificationsOn).Append("\n");
            sb.Append("  ChatUpdateOn: ").Append(ChatUpdateOn).Append("\n");
            sb.Append("  VideoUploadOn: ").Append(VideoUploadOn).Append("\n");
            sb.Append("  Proxy: ").Append(Proxy).Append("\n");
            sb.Append("  GuaranteedHooks: ").Append(GuaranteedHooks).Append("\n");
            sb.Append("  IgnoreOldMessages: ").Append(IgnoreOldMessages).Append("\n");
            sb.Append("  ProcessArchive: ").Append(ProcessArchive).Append("\n");
            sb.Append("  InstanceStatuses: ").Append(InstanceStatuses).Append("\n");
            sb.Append("  WebhookStatuses: ").Append(WebhookStatuses).Append("\n");
            sb.Append("  StatusNotificationsOn: ").Append(StatusNotificationsOn).Append("\n");
            sb.Append("  Update: ").Append(Update).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InlineResponse2005);
        }

        /// <summary>
        /// Returns true if InlineResponse2005 instances are equal
        /// </summary>
        /// <param name="input">Instance of InlineResponse2005 to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InlineResponse2005 input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.WebhookUrl == input.WebhookUrl ||
                    (this.WebhookUrl != null &&
                    this.WebhookUrl.Equals(input.WebhookUrl))
                ) && 
                (
                    this.AckNotificationsOn == input.AckNotificationsOn ||
                    (this.AckNotificationsOn != null &&
                    this.AckNotificationsOn.Equals(input.AckNotificationsOn))
                ) && 
                (
                    this.ChatUpdateOn == input.ChatUpdateOn ||
                    (this.ChatUpdateOn != null &&
                    this.ChatUpdateOn.Equals(input.ChatUpdateOn))
                ) && 
                (
                    this.VideoUploadOn == input.VideoUploadOn ||
                    (this.VideoUploadOn != null &&
                    this.VideoUploadOn.Equals(input.VideoUploadOn))
                ) && 
                (
                    this.Proxy == input.Proxy ||
                    (this.Proxy != null &&
                    this.Proxy.Equals(input.Proxy))
                ) && 
                (
                    this.GuaranteedHooks == input.GuaranteedHooks ||
                    (this.GuaranteedHooks != null &&
                    this.GuaranteedHooks.Equals(input.GuaranteedHooks))
                ) && 
                (
                    this.IgnoreOldMessages == input.IgnoreOldMessages ||
                    (this.IgnoreOldMessages != null &&
                    this.IgnoreOldMessages.Equals(input.IgnoreOldMessages))
                ) && 
                (
                    this.ProcessArchive == input.ProcessArchive ||
                    (this.ProcessArchive != null &&
                    this.ProcessArchive.Equals(input.ProcessArchive))
                ) && 
                (
                    this.InstanceStatuses == input.InstanceStatuses ||
                    (this.InstanceStatuses != null &&
                    this.InstanceStatuses.Equals(input.InstanceStatuses))
                ) && 
                (
                    this.WebhookStatuses == input.WebhookStatuses ||
                    (this.WebhookStatuses != null &&
                    this.WebhookStatuses.Equals(input.WebhookStatuses))
                ) && 
                (
                    this.StatusNotificationsOn == input.StatusNotificationsOn ||
                    (this.StatusNotificationsOn != null &&
                    this.StatusNotificationsOn.Equals(input.StatusNotificationsOn))
                ) && 
                (
                    this.Update == input.Update ||
                    (this.Update != null &&
                    this.Update.Equals(input.Update))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.WebhookUrl != null)
                    hashCode = hashCode * 59 + this.WebhookUrl.GetHashCode();
                if (this.AckNotificationsOn != null)
                    hashCode = hashCode * 59 + this.AckNotificationsOn.GetHashCode();
                if (this.ChatUpdateOn != null)
                    hashCode = hashCode * 59 + this.ChatUpdateOn.GetHashCode();
                if (this.VideoUploadOn != null)
                    hashCode = hashCode * 59 + this.VideoUploadOn.GetHashCode();
                if (this.Proxy != null)
                    hashCode = hashCode * 59 + this.Proxy.GetHashCode();
                if (this.GuaranteedHooks != null)
                    hashCode = hashCode * 59 + this.GuaranteedHooks.GetHashCode();
                if (this.IgnoreOldMessages != null)
                    hashCode = hashCode * 59 + this.IgnoreOldMessages.GetHashCode();
                if (this.ProcessArchive != null)
                    hashCode = hashCode * 59 + this.ProcessArchive.GetHashCode();
                if (this.InstanceStatuses != null)
                    hashCode = hashCode * 59 + this.InstanceStatuses.GetHashCode();
                if (this.WebhookStatuses != null)
                    hashCode = hashCode * 59 + this.WebhookStatuses.GetHashCode();
                if (this.StatusNotificationsOn != null)
                    hashCode = hashCode * 59 + this.StatusNotificationsOn.GetHashCode();
                if (this.Update != null)
                    hashCode = hashCode * 59 + this.Update.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
