/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// Action for change status
    /// </summary>
    [DataContract]
    public partial class InstanceStatusAction :  IEquatable<InstanceStatusAction>, IValidatableObject
    {
        /// <summary>
        /// Method name
        /// </summary>
        /// <value>Method name</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ActEnum
        {
            /// <summary>
            /// Enum Expiry for value: expiry
            /// </summary>
            [EnumMember(Value = "expiry")]
            Expiry = 1,

            /// <summary>
            /// Enum Retry for value: retry
            /// </summary>
            [EnumMember(Value = "retry")]
            Retry = 2,

            /// <summary>
            /// Enum Takeover for value: takeover
            /// </summary>
            [EnumMember(Value = "takeover")]
            Takeover = 3,

            /// <summary>
            /// Enum Logout for value: logout
            /// </summary>
            [EnumMember(Value = "logout")]
            Logout = 4

        }

        /// <summary>
        /// Method name
        /// </summary>
        /// <value>Method name</value>
        [DataMember(Name="act", EmitDefaultValue=false)]
        public ActEnum? Act { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="InstanceStatusAction" /> class.
        /// </summary>
        /// <param name="act">Method name.</param>
        /// <param name="label">Action caption for the button.</param>
        public InstanceStatusAction(ActEnum? act = default(ActEnum?), string label = default(string))
        {
            this.Act = act;
            this.Label = label;
        }
        

        /// <summary>
        /// Action caption for the button
        /// </summary>
        /// <value>Action caption for the button</value>
        [DataMember(Name="label", EmitDefaultValue=false)]
        public string Label { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InstanceStatusAction {\n");
            sb.Append("  Act: ").Append(Act).Append("\n");
            sb.Append("  Label: ").Append(Label).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InstanceStatusAction);
        }

        /// <summary>
        /// Returns true if InstanceStatusAction instances are equal
        /// </summary>
        /// <param name="input">Instance of InstanceStatusAction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InstanceStatusAction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Act == input.Act ||
                    (this.Act != null &&
                    this.Act.Equals(input.Act))
                ) && 
                (
                    this.Label == input.Label ||
                    (this.Label != null &&
                    this.Label.Equals(input.Label))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Act != null)
                    hashCode = hashCode * 59 + this.Act.GetHashCode();
                if (this.Label != null)
                    hashCode = hashCode * 59 + this.Label.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
