/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// More information about instance status
    /// </summary>
    [DataContract]
    public partial class InstanceStatusStatusData :  IEquatable<InstanceStatusStatusData>, IValidatableObject
    {
        /// <summary>
        /// Instance Substatus
        /// </summary>
        /// <value>Instance Substatus</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SubstatusEnum
        {
            /// <summary>
            /// Enum Normal for value: normal
            /// </summary>
            [EnumMember(Value = "normal")]
            Normal = 1,

            /// <summary>
            /// Enum Loading for value: loading
            /// </summary>
            [EnumMember(Value = "loading")]
            Loading = 2,

            /// <summary>
            /// Enum Offline for value: offline
            /// </summary>
            [EnumMember(Value = "offline")]
            Offline = 3,

            /// <summary>
            /// Enum Expired for value: expired
            /// </summary>
            [EnumMember(Value = "expired")]
            Expired = 4,

            /// <summary>
            /// Enum Opening for value: opening
            /// </summary>
            [EnumMember(Value = "opening")]
            Opening = 5,

            /// <summary>
            /// Enum Pairing for value: pairing
            /// </summary>
            [EnumMember(Value = "pairing")]
            Pairing = 6,

            /// <summary>
            /// Enum Timeout for value: timeout
            /// </summary>
            [EnumMember(Value = "timeout")]
            Timeout = 7,

            /// <summary>
            /// Enum Computer for value: computer
            /// </summary>
            [EnumMember(Value = "computer")]
            Computer = 8,

            /// <summary>
            /// Enum Phone for value: phone
            /// </summary>
            [EnumMember(Value = "phone")]
            Phone = 9,

            /// <summary>
            /// Enum Batterylow1 for value: battery_low_1
            /// </summary>
            [EnumMember(Value = "battery_low_1")]
            Batterylow1 = 10,

            /// <summary>
            /// Enum Batterylow2 for value: battery_low_2
            /// </summary>
            [EnumMember(Value = "battery_low_2")]
            Batterylow2 = 11

        }

        /// <summary>
        /// Instance Substatus
        /// </summary>
        /// <value>Instance Substatus</value>
        [DataMember(Name="substatus", EmitDefaultValue=false)]
        public SubstatusEnum? Substatus { get; set; }
        /// <summary>
        /// The reason why the instance is in \&quot;loading\&quot; status
        /// </summary>
        /// <value>The reason why the instance is in \&quot;loading\&quot; status</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ReasonEnum
        {
            /// <summary>
            /// Enum Connecting for value: connecting
            /// </summary>
            [EnumMember(Value = "connecting")]
            Connecting = 1,

            /// <summary>
            /// Enum Syncing for value: syncing
            /// </summary>
            [EnumMember(Value = "syncing")]
            Syncing = 2,

            /// <summary>
            /// Enum Offline for value: offline
            /// </summary>
            [EnumMember(Value = "offline")]
            Offline = 3,

            /// <summary>
            /// Enum Proxyblock for value: proxyblock
            /// </summary>
            [EnumMember(Value = "proxyblock")]
            Proxyblock = 4,

            /// <summary>
            /// Enum Conflict for value: conflict
            /// </summary>
            [EnumMember(Value = "conflict")]
            Conflict = 5

        }

        /// <summary>
        /// The reason why the instance is in \&quot;loading\&quot; status
        /// </summary>
        /// <value>The reason why the instance is in \&quot;loading\&quot; status</value>
        [DataMember(Name="reason", EmitDefaultValue=false)]
        public ReasonEnum? Reason { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="InstanceStatusStatusData" /> class.
        /// </summary>
        /// <param name="substatus">Instance Substatus.</param>
        /// <param name="title">Status title in the language of the instance.</param>
        /// <param name="msg">Status message in the language of the instance.</param>
        /// <param name="submsg">Additional status message in the language of the instance.</param>
        /// <param name="actions">actions.</param>
        /// <param name="reason">The reason why the instance is in \&quot;loading\&quot; status.</param>
        public InstanceStatusStatusData(SubstatusEnum? substatus = default(SubstatusEnum?), string title = default(string), string msg = default(string), string submsg = default(string), InstanceStatusStatusDataActions actions = default(InstanceStatusStatusDataActions), ReasonEnum? reason = default(ReasonEnum?))
        {
            this.Substatus = substatus;
            this.Title = title;
            this.Msg = msg;
            this.Submsg = submsg;
            this.Actions = actions;
            this.Reason = reason;
        }
        

        /// <summary>
        /// Status title in the language of the instance
        /// </summary>
        /// <value>Status title in the language of the instance</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Status message in the language of the instance
        /// </summary>
        /// <value>Status message in the language of the instance</value>
        [DataMember(Name="msg", EmitDefaultValue=false)]
        public string Msg { get; set; }

        /// <summary>
        /// Additional status message in the language of the instance
        /// </summary>
        /// <value>Additional status message in the language of the instance</value>
        [DataMember(Name="submsg", EmitDefaultValue=false)]
        public string Submsg { get; set; }

        /// <summary>
        /// Gets or Sets Actions
        /// </summary>
        [DataMember(Name="actions", EmitDefaultValue=false)]
        public InstanceStatusStatusDataActions Actions { get; set; }


        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class InstanceStatusStatusData {\n");
            sb.Append("  Substatus: ").Append(Substatus).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Msg: ").Append(Msg).Append("\n");
            sb.Append("  Submsg: ").Append(Submsg).Append("\n");
            sb.Append("  Actions: ").Append(Actions).Append("\n");
            sb.Append("  Reason: ").Append(Reason).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as InstanceStatusStatusData);
        }

        /// <summary>
        /// Returns true if InstanceStatusStatusData instances are equal
        /// </summary>
        /// <param name="input">Instance of InstanceStatusStatusData to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(InstanceStatusStatusData input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Substatus == input.Substatus ||
                    (this.Substatus != null &&
                    this.Substatus.Equals(input.Substatus))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Msg == input.Msg ||
                    (this.Msg != null &&
                    this.Msg.Equals(input.Msg))
                ) && 
                (
                    this.Submsg == input.Submsg ||
                    (this.Submsg != null &&
                    this.Submsg.Equals(input.Submsg))
                ) && 
                (
                    this.Actions == input.Actions ||
                    (this.Actions != null &&
                    this.Actions.Equals(input.Actions))
                ) && 
                (
                    this.Reason == input.Reason ||
                    (this.Reason != null &&
                    this.Reason.Equals(input.Reason))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Substatus != null)
                    hashCode = hashCode * 59 + this.Substatus.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Msg != null)
                    hashCode = hashCode * 59 + this.Msg.GetHashCode();
                if (this.Submsg != null)
                    hashCode = hashCode * 59 + this.Submsg.GetHashCode();
                if (this.Actions != null)
                    hashCode = hashCode * 59 + this.Actions.GetHashCode();
                if (this.Reason != null)
                    hashCode = hashCode * 59 + this.Reason.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
