/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// OutboundAction
    /// </summary>
    [DataContract]
    public partial class OutboundAction :  IEquatable<OutboundAction>, IValidatableObject
    {
        /// <summary>
        /// type of the action in queue
        /// </summary>
        /// <value>type of the action in queue</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            /// <summary>
            /// Enum Creategroup for value: create group
            /// </summary>
            [EnumMember(Value = "create group")]
            Creategroup = 1,

            /// <summary>
            /// Enum Addgroupparticipant for value: add group participant
            /// </summary>
            [EnumMember(Value = "add group participant")]
            Addgroupparticipant = 2,

            /// <summary>
            /// Enum Removegroupparticipant for value: remove group participant
            /// </summary>
            [EnumMember(Value = "remove group participant")]
            Removegroupparticipant = 3,

            /// <summary>
            /// Enum Promotegroupparticipant for value: promote group participant
            /// </summary>
            [EnumMember(Value = "promote group participant")]
            Promotegroupparticipant = 4,

            /// <summary>
            /// Enum Demotegroupparticipant for value: demote group participant
            /// </summary>
            [EnumMember(Value = "demote group participant")]
            Demotegroupparticipant = 5,

            /// <summary>
            /// Enum Readchat for value: read chat
            /// </summary>
            [EnumMember(Value = "read chat")]
            Readchat = 6

        }

        /// <summary>
        /// type of the action in queue
        /// </summary>
        /// <value>type of the action in queue</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="OutboundAction" /> class.
        /// </summary>
        /// <param name="id">action id in queue.</param>
        /// <param name="type">type of the action in queue.</param>
        /// <param name="lastTry">Last try time to execute a action.</param>
        /// <param name="jsonData">Additional action data.</param>
        public OutboundAction(int id = default(int), TypeEnum? type = default(TypeEnum?), int lastTry = default(int), Object jsonData = default(Object))
        {
            this.Id = id;
            this.Type = type;
            this.LastTry = lastTry;
            this.JsonData = jsonData;
        }
        
        /// <summary>
        /// action id in queue
        /// </summary>
        /// <value>action id in queue</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int Id { get; set; }


        /// <summary>
        /// Last try time to execute a action
        /// </summary>
        /// <value>Last try time to execute a action</value>
        [DataMember(Name="last_try", EmitDefaultValue=false)]
        public int LastTry { get; set; }

        /// <summary>
        /// Additional action data
        /// </summary>
        /// <value>Additional action data</value>
        [DataMember(Name="json_data", EmitDefaultValue=false)]
        public Object JsonData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutboundAction {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  LastTry: ").Append(LastTry).Append("\n");
            sb.Append("  JsonData: ").Append(JsonData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutboundAction);
        }

        /// <summary>
        /// Returns true if OutboundAction instances are equal
        /// </summary>
        /// <param name="input">Instance of OutboundAction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutboundAction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.LastTry == input.LastTry ||
                    (this.LastTry != null &&
                    this.LastTry.Equals(input.LastTry))
                ) && 
                (
                    this.JsonData == input.JsonData ||
                    (this.JsonData != null &&
                    this.JsonData.Equals(input.JsonData))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.LastTry != null)
                    hashCode = hashCode * 59 + this.LastTry.GetHashCode();
                if (this.JsonData != null)
                    hashCode = hashCode * 59 + this.JsonData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
