/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// OutboundActions
    /// </summary>
    [DataContract]
    public partial class OutboundActions :  IEquatable<OutboundActions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OutboundActions" /> class.
        /// </summary>
        /// <param name="totalActions">Total number of actions in the queue.</param>
        /// <param name="first100">first100.</param>
        public OutboundActions(int totalActions = default(int), List<OutboundAction> first100 = default(List<OutboundAction>))
        {
            this.TotalActions = totalActions;
            this.First100 = first100;
        }
        
        /// <summary>
        /// Total number of actions in the queue
        /// </summary>
        /// <value>Total number of actions in the queue</value>
        [DataMember(Name="totalActions", EmitDefaultValue=false)]
        public int TotalActions { get; set; }

        /// <summary>
        /// Gets or Sets First100
        /// </summary>
        [DataMember(Name="first100", EmitDefaultValue=false)]
        public List<OutboundAction> First100 { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutboundActions {\n");
            sb.Append("  TotalActions: ").Append(TotalActions).Append("\n");
            sb.Append("  First100: ").Append(First100).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutboundActions);
        }

        /// <summary>
        /// Returns true if OutboundActions instances are equal
        /// </summary>
        /// <param name="input">Instance of OutboundActions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutboundActions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TotalActions == input.TotalActions ||
                    (this.TotalActions != null &&
                    this.TotalActions.Equals(input.TotalActions))
                ) && 
                (
                    this.First100 == input.First100 ||
                    this.First100 != null &&
                    input.First100 != null &&
                    this.First100.SequenceEqual(input.First100)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TotalActions != null)
                    hashCode = hashCode * 59 + this.TotalActions.GetHashCode();
                if (this.First100 != null)
                    hashCode = hashCode * 59 + this.First100.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
