/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// OutboundMessage
    /// </summary>
    [DataContract]
    public partial class OutboundMessage :  IEquatable<OutboundMessage>, IValidatableObject
    {
        /// <summary>
        /// type of the message in queue
        /// </summary>
        /// <value>type of the message in queue</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            /// <summary>
            /// Enum Chat for value: chat
            /// </summary>
            [EnumMember(Value = "chat")]
            Chat = 1,

            /// <summary>
            /// Enum Image for value: image
            /// </summary>
            [EnumMember(Value = "image")]
            Image = 2,

            /// <summary>
            /// Enum Ptt for value: ptt
            /// </summary>
            [EnumMember(Value = "ptt")]
            Ptt = 3,

            /// <summary>
            /// Enum Document for value: document
            /// </summary>
            [EnumMember(Value = "document")]
            Document = 4,

            /// <summary>
            /// Enum Audio for value: audio
            /// </summary>
            [EnumMember(Value = "audio")]
            Audio = 5,

            /// <summary>
            /// Enum Video for value: video
            /// </summary>
            [EnumMember(Value = "video")]
            Video = 6,

            /// <summary>
            /// Enum Location for value: location
            /// </summary>
            [EnumMember(Value = "location")]
            Location = 7,

            /// <summary>
            /// Enum Calllog for value: call_log
            /// </summary>
            [EnumMember(Value = "call_log")]
            Calllog = 8

        }

        /// <summary>
        /// type of the message in queue
        /// </summary>
        /// <value>type of the message in queue</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="OutboundMessage" /> class.
        /// </summary>
        /// <param name="id">message id in queue.</param>
        /// <param name="body">text message in queue.</param>
        /// <param name="type">type of the message in queue.</param>
        /// <param name="lastTry">Last try time to send a message.</param>
        /// <param name="metadata">Additional message data.</param>
        public OutboundMessage(int id = default(int), string body = default(string), TypeEnum? type = default(TypeEnum?), int lastTry = default(int), Object metadata = default(Object))
        {
            this.Id = id;
            this.Body = body;
            this.Type = type;
            this.LastTry = lastTry;
            this.Metadata = metadata;
        }
        
        /// <summary>
        /// message id in queue
        /// </summary>
        /// <value>message id in queue</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int Id { get; set; }

        /// <summary>
        /// text message in queue
        /// </summary>
        /// <value>text message in queue</value>
        [DataMember(Name="body", EmitDefaultValue=false)]
        public string Body { get; set; }


        /// <summary>
        /// Last try time to send a message
        /// </summary>
        /// <value>Last try time to send a message</value>
        [DataMember(Name="last_try", EmitDefaultValue=false)]
        public int LastTry { get; set; }

        /// <summary>
        /// Additional message data
        /// </summary>
        /// <value>Additional message data</value>
        [DataMember(Name="metadata", EmitDefaultValue=false)]
        public Object Metadata { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutboundMessage {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Body: ").Append(Body).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  LastTry: ").Append(LastTry).Append("\n");
            sb.Append("  Metadata: ").Append(Metadata).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutboundMessage);
        }

        /// <summary>
        /// Returns true if OutboundMessage instances are equal
        /// </summary>
        /// <param name="input">Instance of OutboundMessage to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutboundMessage input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Body == input.Body ||
                    (this.Body != null &&
                    this.Body.Equals(input.Body))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.LastTry == input.LastTry ||
                    (this.LastTry != null &&
                    this.LastTry.Equals(input.LastTry))
                ) && 
                (
                    this.Metadata == input.Metadata ||
                    (this.Metadata != null &&
                    this.Metadata.Equals(input.Metadata))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Body != null)
                    hashCode = hashCode * 59 + this.Body.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.LastTry != null)
                    hashCode = hashCode * 59 + this.LastTry.GetHashCode();
                if (this.Metadata != null)
                    hashCode = hashCode * 59 + this.Metadata.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
