/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// SendContactRequest
    /// </summary>
    [DataContract]
    public partial class SendContactRequest :  IEquatable<SendContactRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SendContactRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SendContactRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SendContactRequest" /> class.
        /// </summary>
        /// <param name="chatId">**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter..</param>
        /// <param name="phone">**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486..</param>
        /// <param name="contactId">Contact ID | Contact IDs array. Example: \&quot;17633123456@c.us\&quot; or [\&quot;17633123456@c.us\&quot;, \&quot;17633123457@c.us\&quot;] (required).</param>
        public SendContactRequest(string chatId = default(string), int phone = default(int), string contactId = default(string))
        {
            // to ensure "contactId" is required (not null)
            if (contactId == null)
            {
                throw new InvalidDataException("contactId is a required property for SendContactRequest and cannot be null");
            }
            else
            {
                this.ContactId = contactId;
            }
            
            this.ChatId = chatId;
            this.Phone = phone;
        }
        
        /// <summary>
        /// **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
        /// </summary>
        /// <value>**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.</value>
        [DataMember(Name="chatId", EmitDefaultValue=false)]
        public string ChatId { get; set; }

        /// <summary>
        /// **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
        /// </summary>
        /// <value>**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.</value>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public int Phone { get; set; }

        /// <summary>
        /// Contact ID | Contact IDs array. Example: \&quot;17633123456@c.us\&quot; or [\&quot;17633123456@c.us\&quot;, \&quot;17633123457@c.us\&quot;]
        /// </summary>
        /// <value>Contact ID | Contact IDs array. Example: \&quot;17633123456@c.us\&quot; or [\&quot;17633123456@c.us\&quot;, \&quot;17633123457@c.us\&quot;]</value>
        [DataMember(Name="contactId", EmitDefaultValue=false)]
        public string ContactId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SendContactRequest {\n");
            sb.Append("  ChatId: ").Append(ChatId).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("  ContactId: ").Append(ContactId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SendContactRequest);
        }

        /// <summary>
        /// Returns true if SendContactRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of SendContactRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SendContactRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ChatId == input.ChatId ||
                    (this.ChatId != null &&
                    this.ChatId.Equals(input.ChatId))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                ) && 
                (
                    this.ContactId == input.ContactId ||
                    (this.ContactId != null &&
                    this.ContactId.Equals(input.ContactId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ChatId != null)
                    hashCode = hashCode * 59 + this.ChatId.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                if (this.ContactId != null)
                    hashCode = hashCode * 59 + this.ContactId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
