/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// SendMessageRequest
    /// </summary>
    [DataContract]
    public partial class SendMessageRequest :  IEquatable<SendMessageRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SendMessageRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SendMessageRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SendMessageRequest" /> class.
        /// </summary>
        /// <param name="chatId">**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter..</param>
        /// <param name="phone">**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486..</param>
        /// <param name="body">Message text, UTF-8 or UTF-16 string with emoji 🍏 (required).</param>
        public SendMessageRequest(string chatId = default(string), int phone = default(int), string body = default(string))
        {
            // to ensure "body" is required (not null)
            if (body == null)
            {
                throw new InvalidDataException("body is a required property for SendMessageRequest and cannot be null");
            }
            else
            {
                this.Body = body;
            }
            
            this.ChatId = chatId;
            this.Phone = phone;
        }
        
        /// <summary>
        /// **Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.
        /// </summary>
        /// <value>**Required if phone is not set**  Chat ID from the message list. Examples: 17633123456@c.us for private messages and 17680561234-1479621234@g.us for the group. Used instead of the phone parameter.</value>
        [DataMember(Name="chatId", EmitDefaultValue=false)]
        public string ChatId { get; set; }

        /// <summary>
        /// **Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.
        /// </summary>
        /// <value>**Required if chatId is not set**  A phone number starting with the country code. You do not need to add your number.   USA example: 17472822486.</value>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public int Phone { get; set; }

        /// <summary>
        /// Message text, UTF-8 or UTF-16 string with emoji 🍏
        /// </summary>
        /// <value>Message text, UTF-8 or UTF-16 string with emoji 🍏</value>
        [DataMember(Name="body", EmitDefaultValue=false)]
        public string Body { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SendMessageRequest {\n");
            sb.Append("  ChatId: ").Append(ChatId).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("  Body: ").Append(Body).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SendMessageRequest);
        }

        /// <summary>
        /// Returns true if SendMessageRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of SendMessageRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SendMessageRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ChatId == input.ChatId ||
                    (this.ChatId != null &&
                    this.ChatId.Equals(input.ChatId))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                ) && 
                (
                    this.Body == input.Body ||
                    (this.Body != null &&
                    this.Body.Equals(input.Body))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ChatId != null)
                    hashCode = hashCode * 59 + this.ChatId.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                if (this.Body != null)
                    hashCode = hashCode * 59 + this.Body.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
