/* 
 * Chat API SDK
 *
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// WebhookUrl
    /// </summary>
    [DataContract]
    public partial class WebhookUrl :  IEquatable<WebhookUrl>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="WebhookUrl" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected WebhookUrl() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="WebhookUrl" /> class.
        /// </summary>
        /// <param name="webhookUrl">Http or https URL for receiving notifications. For testing, we recommend using [our RequestBin](http://bin.chat-api.com). (required).</param>
        public WebhookUrl(string webhookUrl = default(string))
        {
            // to ensure "webhookUrl" is required (not null)
            if (webhookUrl == null)
            {
                throw new InvalidDataException("webhookUrl is a required property for WebhookUrl and cannot be null");
            }
            else
            {
                this._WebhookUrl = webhookUrl;
            }
            
        }
        
        /// <summary>
        /// Http or https URL for receiving notifications. For testing, we recommend using [our RequestBin](http://bin.chat-api.com).
        /// </summary>
        /// <value>Http or https URL for receiving notifications. For testing, we recommend using [our RequestBin](http://bin.chat-api.com).</value>
        [DataMember(Name="webhookUrl", EmitDefaultValue=false)]
        public string _WebhookUrl { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class WebhookUrl {\n");
            sb.Append("  _WebhookUrl: ").Append(_WebhookUrl).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as WebhookUrl);
        }

        /// <summary>
        /// Returns true if WebhookUrl instances are equal
        /// </summary>
        /// <param name="input">Instance of WebhookUrl to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(WebhookUrl input)
        {
            if (input == null)
                return false;

            return 
                (
                    this._WebhookUrl == input._WebhookUrl ||
                    (this._WebhookUrl != null &&
                    this._WebhookUrl.Equals(input._WebhookUrl))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this._WebhookUrl != null)
                    hashCode = hashCode * 59 + this._WebhookUrl.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
